--- old/usr/src/uts/common/rpc/svc_clts.c	2012-11-26 15:07:17.162320457 +0400
+++ new/usr/src/uts/common/rpc/svc_clts.c	2012-11-26 15:07:16.446320439 +0400
@@ -26,6 +26,10 @@
 /*	  All Rights Reserved  	*/
 
 /*
+ * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
+ */
+
+/*
  * Portions of this source code were derived from Berkeley 4.3 BSD
  * under license from the Regents of the University of California.
  */
@@ -108,6 +112,7 @@
 struct udp_data {
 	mblk_t	*ud_resp;			/* buffer for response */
 	mblk_t	*ud_inmp;			/* mblk chain of request */
+	sin6_t	ud_local;			/* local address */
 };
 
 #define	UD_MAXSIZE	8800
@@ -321,6 +326,8 @@
 	    pptr->unitdata_ind.SRC_offset;
 	clone_xprt->xp_rtaddr.len = pptr->unitdata_ind.SRC_length;
 
+	clone_xprt->xp_lcladdr.buf = (char *)&ud->ud_local;
+
 	/*
 	 * Copy the local transport address in the service_transport
 	 * handle at the address in the request. We will have only
